org.cpsolver.ifs.dbt

## Class DbtVariableSelection<V extends Variable<V,T>,T extends Value<V,T>>

- java.lang.Object
- - org.cpsolver.ifs.dbt.DbtVariableSelection<V,T>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Implemented Interfaces:
    VariableSelection<V,T>

      public class DbtVariableSelection<V extends Variable<V,T>,T extends Value<V,T>>
      extends Object
      implements VariableSelection<V,T>

  Selection of a variable for dynamic backtracking.
  - Returns null if all variables are assigned.
  - Checks if there is a varaible with all values marked as nogood (and pick it if there is any).
  - Returns the first unassigned variable.
  This IFS solver variable selection heuristics is to be used only in case of dynamic backtracking and it has no parameters.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DbtVariableSelection(DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<V,T> solver)` Heuristics initialization
    `V` | `selectVariable(Solution<V,T> solution)` Variable selection

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DbtVariableSelection

          public DbtVariableSelection(DataProperties properties)

  - ### Method Detail

    - #### init

          public void init(Solver<V,T> solver)

      Heuristics initialization
      Specified by:
        `init` in interface `VariableSelection<V extends Variable<V,T>,T extends Value<V,T>>`
      Parameters:
        `solver` - current solver
      See Also:
        `VariableSelection.init(Solver)`

    - #### selectVariable

          public V selectVariable(Solution<V,T> solution)

      Variable selection
      Specified by:
        `selectVariable` in interface `VariableSelection<V extends Variable<V,T>,T extends Value<V,T>>`
      Parameters:
        `solution` - current solution
      Returns:
        selected variable
      See Also:
        `VariableSelection.selectVariable(Solution)`